#!/usr/bin/python3

# Copyright (C) 2014-2021, Josef Hahn
#
# This file is part of Yaji.
#
# Yaji is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Yaji is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Yaji.  If not, see <http://www.gnu.org/licenses/>.

import ___sampleapp  # this is just an internal hack - just ignore it and don't copy it!

import yaji


class Application(yaji.Application):

    def __init__(self):
        super().__init__(head1="Yaji Sample", head2="bindings&converters", stop_implicitly_when_browser_closed=True)
        with self.create_clientlocal_datastore("h00") as h00:
            h00.setvalue("Something fooish")
        with self.create_datastore("h01") as h01:
            h01.setvalue("Something -&gt; barish")
        self.setbodyleft(yaji.Grid(
            yaji.View(label="local", style="font-size:1.4em", row=0, col=1),
            yaji.View(label="server", style="font-size:1.4em", row=0, col=2),

            yaji.View(label="editbox with converter", style="font-size:1.4em", row=1),
            yaji.View('EditBox', row=2, col=1, text=self.binddata('h00', convertername="FooConverter")),
            yaji.View('EditBox', row=2, col=2, text=self.binddata('h01', convertername="FooConverter")),

            yaji.View(label="original value", style="font-size:1.4em", row=3),
            yaji.View('Label', row=4, col=1, label=self.binddata('h00'), style="color:slategray", height="2em"),
            yaji.View('Label', row=4, col=2, label=self.binddata('h01'), style="color:slategray"),

            yaji.View(label="editbox with other converter", style="font-size:1.4em", row=5),
            yaji.View('EditBox', row=6, col=1, text=self.binddata('h00', convertername="BarConverter")),
            yaji.View('EditBox', row=6, col=2, text=self.binddata('h01', convertername="BarConverter")),

        ))


if __name__ == '__main__':
    Application().start()
