#!/usr/bin/python3

# Copyright (C) 2014-2021, Josef Hahn
#
# This file is part of Yaji.
#
# Yaji is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Yaji is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Yaji.  If not, see <http://www.gnu.org/licenses/>.

import ___sampleapp  # this is just an internal hack - just ignore it and don't copy it!

import yaji


class Application(yaji.Application):

    def __init__(self):
        super().__init__(head1="Yaji Sample", head2="request", stop_implicitly_when_browser_closed=True)
        self.setbodyleft(yaji.View('Button', label=f"Go",
                                   OnClicked=self.bindevent(yaji.BackendFunction('something?foo=bar&foo=barr',
                                                                                 {'baz': 1337}))))

    @yaji.RequestHandler.for_urls(auto=True)
    def _do_something(self, **_):
        self.setbodyleft(yaji.View('Label', label=f"""
self.current_request…

.urlpath: {self.current_request.urlpath}
.urlbarepath: {self.current_request.urlbarepath}
.urlpathquery: {self.current_request.urlpathquery}

.params: {self.current_request.params}

.lparams: {self.current_request.lparams}

.header: {self.current_request.header}
"""))


if __name__ == '__main__':
    Application().start()
