#!/usr/bin/python3

# Copyright (C) 2014-2021, Josef Hahn
#
# This file is part of Yaji.
#
# Yaji is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Yaji is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Yaji.  If not, see <http://www.gnu.org/licenses/>.

import ___sampleapp  # this is just an internal hack - just ignore it and don't copy it!

import time

import yaji


class Application(yaji.Application):

    def __init__(self):
        super().__init__(head1="Yaji Sample", head2="downstream requesthandler",
                         stop_implicitly_when_browser_closed=True)
        self.progress = self.create_datastore()
        self.progress.setvalue(0)
        self.setbodyleft(yaji.View('Button', label=f"Go", OnClicked=self.bindevent(yaji.BackendFunction('something'))))
        self.setbodyright(yaji.View('ProgressBar', value=self.binddata(self.progress), hstretch=1))

    @yaji.RequestHandler.run_downstream()
    @yaji.RequestHandler.for_urls(auto=True)
    def _do_something(self):
        self.progress.setvalue(0)
        for i in range(100):
            self.progress.setvalue(self.progress.getvalue() + .01)
            time.sleep(1)


if __name__ == '__main__':
    Application().start()
