# Copyright (C) 2014-2021, Josef Hahn
#
# This file is part of anise.
#
# anise is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# anise is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with anise.  If not, see <http://www.gnu.org/licenses/>.

"""
The infrastructure parts of Anise.

The infrastructure executes Python code in a :file:`_projectdesc` file and
makes some syntactical tricks leading to shorter (and better readable) files. This tricks include the direct
access to the universe object and the automatic imports it makes before executing :file:`_projectdesc`.

In most places, the Anise infrastructure tries to be as thin a layer above Python as possible instead of reinventing
the wheel again and again. Although on some places Anise actually has to do some more own stuff in order to bring
some functionality.

Read about the individual infrastructure parts in the subpackages here.

The starting point is :py:mod:`anise.framework.engine`, which is the active part responsible for executing tasks.
"""
