# Copyright (C) 2014-2021, Josef Hahn
#
# This file is part of anise.
#
# anise is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# anise is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with anise.  If not, see <http://www.gnu.org/licenses/>.

import anise.test.anisetest


_projectdesc = """<?xml version="1.0" ?>
<aniseprojectdesc>
    <let k="base.pyscript">
        <val k="hook" oref="engine.HOOK_AFTER_PREPARATION"/>
        <val k="code">
def fct():
    def result():
        pyunit = universe.pyunit
        r = files.TempDir()
        os.makedirs(r.path + "/foo")
        utils.basic.writetofile(r.path + "/foo/x", "FOO")
        r2 = files.TempDir()
        r.dl(r2.path+"/orig")
        r.dl(r2.path+"/orig2", subpath="/foo")
        pyunit.assertEqual("FOO", utils.basic.readfromfile(r2.path+"/orig/foo/x"))
        pyunit.assertEqual("FOO", utils.basic.readfromfile(r2.path+"/orig2/x"))
        r = files.Filestructure(r2.path+"/orig/foo")
        r3 = r.with_modified_rootname("bar")
        pyunit.assertEqual("FOO", utils.basic.readfromfile(r3.path+"/x"))
        pyunit.assertEqual("bar", os.path.basename(r3.path))
        pyunit.assertEqual("FOO", utils.basic.readfromfile(r2.path+"/orig/foo/x"))
        r.mv("baz")
        pyunit.assertEqual("FOO", utils.basic.readfromfile(r2.path+"/orig/baz/x"))
        pyunit.assertIsNone(utils.basic.readfromfile(r2.path+"/orig/foo/x", notexist_default=None))
    universe.result = result
        </val>
    </let>
</aniseprojectdesc>
"""


class Test(anise.test.anisetest.AniseTestCase):

    def __init__(self, *a, **kwa):
        super().__init__(*a, projectdesc=_projectdesc, **kwa)

    def test_a(self):
        self.runanise("result", values={'pyunit': self})
